// ============================================================================
//
// Test1.c
// Prints out Hello message with thread number
// CBP 25-03-22
// Part of NoC Multi-Processing Workshops
// Status: Release
//
// ============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <omp.h>

int tid;
int nrProcs;

int main(int argc, char** argv) {

	printf("============== CBP NoC 2022 Multi-Processing Workshops ============\n\n");
	printf("---------------------------Activity 1------------------------------\n");

	printf("Request to system for coresand threads\n");
	system("WMIC CPU Get NumberofCores,NumberOfLogicalProcessors");

	nrProcs = omp_get_num_procs();
	printf("OMP says nr of threads on this machine = %d\n", nrProcs);

	tid = omp_get_thread_num();
	printf("\nIn sequential region: Thread %d printf Hello Cat\n\n", tid);

	printf("Entering parallel region-------------------------------------------\n\n");
	#pragma omp parallel 
	{
		tid = omp_get_thread_num();
		printf("In parallel region: Thread %d printf Hello Cat\n", tid);

	}

	tid = omp_get_thread_num();
	printf("\nBack to sequential region: Thread %d printf Hello Cat\n", tid);
}

