// ============================================================================
//
// Task11.c
// CBP 26-03-22
// Data Race This cannot be parallelized
// Part of NoC Multi-Processing Workshops
// Status: Release
//
// ============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <omp.h>

#define VEC_LEN 100
#define NR_ITERATIONS 10

int count;
int nrProcs;
int i;
int a[VEC_LEN];
int b[VEC_LEN];

int main(int argc, char** argv) {

	printf("============== CBP NoC 2022 Multi-Processing Workshops ============\n\n");
	printf("---------------------------Activity 11 ----------------------------\n");

	printf("Request to system for coresand threads\n");
	system("WMIC CPU Get NumberofCores,NumberOfLogicalProcessors");

	nrProcs = omp_get_num_procs();
	printf("OMP says nr of threads on this machine = %d\n", nrProcs);

	omp_set_dynamic(0);
	omp_set_num_threads(16);

	count = 0;
	while (count < NR_ITERATIONS) {
		for (i = 0; i < VEC_LEN; i++) {
			a[i] = i;
			b[i] = i;
		}

		#pragma omp parallel
		{
			#pragma omp for
			for (i = 0; i < VEC_LEN - 1; i++) {
				a[i] = a[i + 1] + b[i];
			}
		}

		printf("a[%d] = %d\n", VEC_LEN/2, a[VEC_LEN/2]);
		count++;
	}



}