// ============================================================================
//
// Task2.c
// CBP 21-03-22
// PROOF that each thread handles a single array element
// Part of NoC Multi-Processing Workshops
// Status: Release
//
// ============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <omp.h>

#define ARRAY_LENGTH 5

int threadNr;
int nrProcs;
int nrProcsDes;
int nrThreads;
int a[ARRAY_LENGTH];
int i;
int tid;
int tnum;

int main(int argc, char** argv) {

	printf("============== CBP NoC 2022 Multi-Processing Workshops ============\n\n");
	printf("------------------------- Activity 2 ------------------------------\n");

	printf("Request to system for coresand threads\n");
	system("WMIC CPU Get NumberofCores,NumberOfLogicalProcessors");

	nrProcs = omp_get_num_procs();
	printf("OMP says nr of threads on this machine = %d\n", nrProcs);

	tid = omp_get_thread_num();

	printf("Array length for this activity: %d\n", ARRAY_LENGTH);

	printf("Nr processors limited to %d\n", ARRAY_LENGTH);

	omp_set_dynamic(0);
	omp_set_num_threads(ARRAY_LENGTH);

	printf("\n>>> Entering Parallel region ----------------------------\n\n");

	#pragma omp parallel private(tid)  //Parallel region tid is private
	{
		#pragma omp for // parallel 4 loop
		for (i = 0; i < ARRAY_LENGTH; i++) {
			a[i] = 3 * i;
			tid = omp_get_thread_num();

			if (tid == 0)  printf("PROOF+++ Thread %d assigned: a[%d] = %d\n", tid, i, a[i]);
			if (tid == 1)  printf("PROOF+++ Thread %d assigned: a[%d] = %d\n", tid, i, a[i]);
			if (tid == 2)  printf("PROOF+++ Thread %d assigned: a[%d] = %d\n", tid, i, a[i]);
			if (tid == 3)  printf("PROOF+++ Thread %d assigned: a[%d] = %d\n", tid, i, a[i]);
			if (tid == 4)  printf("PROOF+++ Thread %d assigned: a[%d] = %d\n", tid, i, a[i]);

		}
	}

	printf("\n>>> Exited Parallel region --------------------------------\n\n");
	for (i = 0; i < ARRAY_LENGTH; i++) {
		printf("a[%d] = %d\n", i, a[i]);
	}

}