// ============================================================================
//
// Test3.c
// Sums elements of a vector uses a critical region
// CBP 25-03-22
// Part of NoC Multi-Processing Workshops
// Status: Release
//
// ============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <omp.h>

int tid;
int nrProcs;
int sum;
int a[10];
int threadNr;
int sumLocal;

int main(int argc, char** argv) {

	printf("============== CBP NoC 2022 Multi-Processing Workshops ============\n\n");
	printf("---------------------------Activity 3 -----------------------------\n");

	printf("Request to system for coresand threads\n");
	system("WMIC CPU Get NumberofCores,NumberOfLogicalProcessors");

	nrProcs = omp_get_num_procs();
	printf("OMP says nr of threads on this machine = %d\n", nrProcs);

	omp_set_dynamic(0);
	omp_set_num_threads(nrProcs);

	for (int i = 0; i < 10; i++) {
		a[i] = i;
	}
	sum = 0;

	printf("Entering parallel region-------------------------------------------\n\n");

	#pragma omp parallel shared(a,sum) private(threadNr, sumLocal)
	{
		threadNr = omp_get_thread_num();
		sumLocal = 0;
		#pragma omp for
		for (int i = 0; i < 10; i++) {
			sumLocal += a[i];
		}
		#pragma omp critical(update_sum)
		{
			sum += sumLocal;
			printf("thread %d sumLocal = %d sum = %d\n", threadNr, sumLocal, sum);
		}

	}
	printf("\nSum after parallel regions = %d -----------------------------------\n", sum);

}