// ============================================================================
//
// Task5.c was Ramblings Test8.c
// CBP 18-03-22
// Basic Timing Tests
// Use PROBSIZE (array length) as independent variable
// Could use this as an argument and use malloc.
// Part of NoC Multi-Processing Workshops
// Status: Release
//
// ============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <time.h>		// Needed for clock_t
#include <string.h>
#include <omp.h>

#define PROBSIZE 20000
#define REQU_NR_THREADS 16

int threadNr;
int x;
int y;
clock_t t0, t1, t2;
double time1, time2;
int nrProcs;
int nrThreads;
double wtime;
double a[PROBSIZE];
double b[PROBSIZE];
double c[PROBSIZE];

int main(int argc, char** argv) {

	printf("============== CBP NoC 2022 Multi-Processing Workshops ============\n\n");
	printf("---------------------------Activity 5------------------------------\n");

	printf("Request to system for coresand threads\n");
	system("WMIC CPU Get NumberofCores,NumberOfLogicalProcessors");

	nrProcs = omp_get_num_procs();
	printf("OMP says nr of threads on this machine = %d\n", nrProcs);

	printf("PROBSIZE = %d\n", PROBSIZE);

	omp_set_dynamic(0);    
	omp_set_num_threads(REQU_NR_THREADS);

	printf("Nr Threads requested = %d\n", REQU_NR_THREADS);

	for (int i = 0; i < PROBSIZE; i++) {
		a[i] = i;
		b[i] = 10.0 * i;
	}

	t0 = clock();
	wtime = omp_get_wtime();

	t1 = clock();

	for (int repeat = 0; repeat < 100000; repeat++) {
	#pragma omp parallel
		{
			if (repeat == 0) {
				nrThreads = omp_get_num_threads();
				printf("Nr threads for this run = %d\n", nrThreads);
			}
			#pragma omp for
			for (int i = 0; i < PROBSIZE; i++) {
				c[i] = a[i] * b[i];
			}
		}
	}

	t2 = clock();
	time2 = (double)(t2)-(double)(t1);
	printf("clock() Time = %f (ms)\n", time2);

	wtime = omp_get_wtime() - wtime;
	printf("wtime = %f (mSec)\n", 1000 * wtime);

}