// ============================================================================
//
// Task6.c
// CBP 23-03-22
// Simple sequential matrix * vector
// Part of NoC Multi-Processing Workshops
// Status: Release
//
// ============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <time.h>		// Needed for clock_t
#include <string.h>
#include <omp.h>

#define REQU_NR_THREADS 1
#define NR_ROWS 2
#define NR_COLS 3

int threadNr;
int x;
int y;
clock_t t0, t1, t2;
double time1, time2;
int nrProcs;
int nrThreads;
double wtime;

int a[NR_ROWS];
int b[NR_ROWS * NR_COLS];
int c[NR_COLS];

double sum;
int nrRows, nrCols;


int main(int argc, char** argv) {

	printf("============== CBP NoC 2022 Multi-Processing Workshops ============\n\n");
	printf("---------------------------Activity 6 -----------------------------\n");

	printf("Request to system for coresand threads\n");
	system("WMIC CPU Get NumberofCores,NumberOfLogicalProcessors");

	nrProcs = omp_get_num_procs();
	printf("OMP says nr of threads on this machine = %d\n", nrProcs);

	omp_set_dynamic(0);     // Explicitly disable dynamic teams
	omp_set_num_threads(REQU_NR_THREADS);

	printf("Nr Threads requested = %d\n", REQU_NR_THREADS);

	nrRows = NR_ROWS;
	nrCols = NR_COLS;

	b[0] = 1;
	b[1] = 2;
	b[2] = 3;
	b[3] = 4;
	b[4] = 5;
	b[5] = 6;

	c[0] = 1;
	c[1] = 2;
	c[2] = 3;

	for (int row = 0; row < nrRows; row++) {
		a[row] = 0;
		for (int col = 0; col < nrCols; col++) {
			a[row] += b[row * nrCols + col] * c[col];
		}
	}

	for (int row = 0; row < nrRows; row++) {
		printf("a[%d] = %d\n", row, a[row]);
	}

}