// ============================================================================
//
// Task8.c
// CBP 04-03-22
// Barrier function with times. MIT4.47
// Part of NoC Multi-Processing Workshops
// Status: Release
//
// ============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <time.h>		// Needed for clock_t
#include <string.h>
#include <omp.h>
#include <Windows.h>	// Needed for Sleep(millisec)

int threadNr;
int x;
int y;
clock_t t0, t1, t2;
double time1, time2;
int nrProcs;

int main(int argc, char** argv) {

	printf("============== CBP NoC 2022 Multi-Processing Workshops ============\n\n");
	printf("---------------------------Activity 8 -----------------------------\n");

	printf("Request to system for coresand threads\n");
	system("WMIC CPU Get NumberofCores,NumberOfLogicalProcessors");

	nrProcs = omp_get_num_procs();
	printf("OMP says nr of threads on this machine = %d\n", nrProcs);

	t0 = clock();
	
	#pragma omp parallel private(threadNr)
	{
		threadNr = omp_get_thread_num();
		if (threadNr < 4) Sleep(1000);
		t1 = clock();
		time1 = (double)(t1 - t0) / CLOCKS_PER_SEC;
		printf("Thread %d before barrier t = %f secs\n", threadNr, time1);

		#pragma omp barrier

		#pragma omp single
		printf("\n");

		t2 = clock();
		time2 = (double)(t2 - t0) / CLOCKS_PER_SEC;
		printf("Thread %d after barrier t = %f secs\n", threadNr, time2);

	}

}