// ============================================================================
//
// Task9.c
// CBP 04-03-22
// Sections Construct 1
// Part of NoC Multi-Processing Workshops
// Status: Release
//
// ============================================================================

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <omp.h>

#define LENGTH 10
int threadNr;
int i, j, n;
double a[LENGTH];
double b[LENGTH];
int nrProcs;
int tid;

int main(int argc, char** argv) {

	printf("============== CBP NoC 2022 Multi-Processing Workshops ============\n\n");
	printf("---------------------------Activity 9 -----------------------------\n");

	printf("Request to system for coresand threads\n");
	system("WMIC CPU Get NumberofCores,NumberOfLogicalProcessors");

	nrProcs = omp_get_num_procs();
	printf("OMP says nr of threads on this machine = %d\n", nrProcs);

	omp_set_dynamic(0);
	omp_set_num_threads(4);

	n = LENGTH;
	printf("\nEntering the parallel region \n\n");

	#pragma omp parallel shared(n,a,b) private(i)
	{

		//#pragma omp for
		for (i = 0; i < n; i++) {
			a[i] = i;
			tid = omp_get_thread_num();
			printf("Thread %d initializing a[%d] = %f\n", tid, i, a[i]);
		}

		//#pragma omp barrier

		#pragma omp for
		for (i = 0; i < n; i++) {
			b[i] = 2 * a[i];
			tid = omp_get_thread_num();
			printf("Thread %d calculating b[%d] = %f\n", tid, i, b[i]);
		}

	}

	printf("\nExit from the parallel region\n\n");

	for (int i = 0; i < n; i++) {
		printf("b[%d] = %f\n", i, b[i]);
	}

}